clear
clc

global Ir It Il Irl Itl Irt Asat etat_init vitesse_rotation altitude points_trace tau vitesse_angul_mini
global Kbpoint w_spin axe_spin Kturbulence KXretourn KYretourn KY

% ***************  Gain de la rgulation Bpoint ( type Damilano )devant la drive de B **********

 Kbpoint=600000; 

% *************************************************************************************************
% Nombre de points du trac
 points_trace=60000;
% *************************************************************************************************

%   **********  VALEURS INITIALES POUR UN RETOURNEMENT AVEC SPIN INITIAL SUR y=Y  ******

if (KXretourn==1) & (KYretourn==0) & (Kturbulence==0) & (KY==0)
              % Initialisation en position (rd), au dpart stabilisation presque parfaite xyz = XYZ 
  w_spin=-0.00875*5;               % Vitesse algbrique de spin en rd/s
  axe_spin=[0 0 1];                % Axe de spin, pour terminer avec une rotation w autour de -Z

  roulis0=0.001;
  tangage0=0.002;
  lacet0=0.001;
               % Initialisation en vitesse en rd/s
  v_roulis0=w_spin+2*vitesse_rotation;   % Au dpart spin suivant x
  v_tangage0=0;   
  v_lacet0=0;
end
%                     ****** $$$$$ Vrifi $$$$$ ******

if (KXretourn==11) & (KYretourn==0) & (Kturbulence==0)
  % *******************  Initialisation en position (rd), au dpart stabilisation parfaite xyz = XYZ *****************
  w_spin=-0.00875*5;               % Vitesse algbrique de spin en rd/s
  axe_spin=[0 1 0];                % Axe de spin, pour terminer avec une rotation w autour de +Y
  roulis0=0;
  tangage0=0;
  lacet0=0;
          % Initialisation en vitesse en rd/s
  v_roulis0=w_spin+2*vitesse_rotation;            % Au dpart spin suivant y=Y
  v_tangage0=0
  v_lacet0=0;
  
end

%                         ****** $$$$$ Vrifi $$$$$ ******
% *****************  Initialisation grosses turbulences en vitesses  ********************
if Kturbulence==1
                % Initialisation en vitesse en rd/s
   w_spin=0;                     % Vitesse algbrique de spin en rd/s
   axe_spin=[1 0 0];             % Axe de spin,sans intrt

   v_roulis0=0.06;
   v_tangage0=0.095;
   v_lacet0=0.01;
                % Initialisation en position (rd)
   roulis0=0.10;
   tangage0=-0.2;
   lacet0=0.05;
 end

%                            ***** $$$$$ Vrifi $$$$$ *******

% ************************* Retournement diect de de X vers -Y ******************************
if (KYretourn==1)& (KXretourn==0) & (Kturbulence==0) & (KY==0)
   % Initialisation en vitesses (rd/s) avec spin sur l'axe y=-Y

   w_spin=0.00875*5;               % Vitesse algbrique de spin en rd/s
   axe_spin=[0 1 0];               % Axe de spin, pour terminer avec une rotation w autour de +Y
   v_roulis0=0;
   v_tangage0=-0.00875*5;
   v_lacet0=0;
   % Initialisation en position (rd) avec xyz confondu avec XYZ
   roulis0=0;   
   tangage0=0;
   lacet0=0;
end
%                            $$$$$ Vrifi $$$$$

% ***************************  DONNEES INVARIABLES **************************

% Matrice d''inertie satellite

% Ir=32e-3;It=36e-3;Il=22e-3;Irt=5.8e-5;Irl=3e-4;Itl=4e-3;

Ir=32e-3;It=36e-3;Il=22e-3;Irt=0;Irl=0;Itl=0;  %  Matrice diagonale

%Ir=22e-3;It=36e-3;Il=22e-3;Irt=0;Irl=0;Itl=0;  %  Matrice diagonale et de rvolution /y

Asat=[Ir -Irt -Irl;
         -Irt It -Itl;
            -Irl -Itl Il];

% Caractristiques de l'orbite du satellite

altitude_orbite=817;		                 % altitude satellite en km
rayon_orbital=(6378+altitude_orbite)*1000;
vitesse_rotation=sqrt(39.86e13/rayon_orbital^3); % pulsation orbitale en rd/s
inclinaison=98.7*pi/180;                         % Inclinaison orbitale convertie en rd
periode_orbitale=2*pi/vitesse_rotation;          % Priode orbitale en s

% ***************** DONNEES PERTURBATIONS********************

% ******************** Donnes annexes*************************

mom_magn_res=0.01; %  Moment magntique rsiduel en Am

alpha=sqrt(1/3);beta=sqrt(1/3);gamma=sqrt(1/3); % Direction unitaire /satellite du moment rsiduel

cpl_aero1=0;
cpl_aero2=-3.6e-8;% COUPLE AERODYNAMIQUE
cpl_aero3=0;

% **********************************************************************

% ****** CALCULS D'INITIALISATION DU VECTEUR D'ETAT ********

% Rotation absolue compose de la rotation par rapport au repre orbital
% et de la rotation  vitesse_rotation porte par Y

vp0=v_roulis0+v_lacet0*sin(tangage0)+...
    vitesse_rotation*sin(lacet0)*cos(tangage0);

vq0=v_lacet0*cos(tangage0)*sin(roulis0)+v_tangage0*cos(roulis0)+...
    vitesse_rotation*(cos(lacet0)*cos(roulis0)+...
    sin(tangage0)*sin(roulis0)*sin(lacet0));

vr0=v_lacet0*cos(tangage0)*cos(roulis0)-v_tangage0*sin(roulis0)+...
    vitesse_rotation*(-cos(lacet0)*sin(roulis0)+...
    sin(tangage0)*cos(roulis0)*sin(lacet0));
   

% ---- Calcul du quaternion initial connaissant les angles initiaux

% Matrice de passage P de la base fixe XYZ  la base satellite xyz
%  l'instant initial

Pmat(1,1)=cos(tangage0)*cos(lacet0);
Pmat(1,2)=-sin(lacet0)*cos(roulis0)+cos(lacet0)*sin(roulis0)*sin(tangage0);
Pmat(1,3)=sin(lacet0)*sin(roulis0)+cos(lacet0)*cos(roulis0)*sin(tangage0);

Pmat(2,1)=cos(tangage0)*sin(lacet0);
Pmat(2,2)=cos(lacet0)*cos(roulis0)+sin(lacet0)*sin(roulis0)*sin(tangage0);
Pmat(2,3)=-cos(lacet0)*sin(roulis0)+sin(lacet0)*cos(roulis0)*sin(tangage0);

Pmat(3,1)=-sin(tangage0);
Pmat(3,2)=sin(roulis0)*cos(tangage0);
Pmat(3,3)=cos(roulis0)*cos(tangage0);

% determinant=det(Pmat),% ************* Bien vrifi ***********

% Calcul du quaternion initial
%
% Nous prenons toujours q0 >0 ou nul

trac=trace(Pmat);

qt00=(1+trac)^0.5/2;

qt10=(1-trac+2*Pmat(1,1))^0.5/2;

qt20=(1-trac+2*Pmat(2,2))^0.5/2;

qt30=(1-trac+2*Pmat(3,3))^0.5/2;

if abs(qt00)>1e-8, 
qt10=qt10*sign((Pmat(3,2)-Pmat(2,3))/4/qt00);
qt20=qt20*sign((Pmat(1,3)-Pmat(3,1))/4/qt00);
qt30=qt30*sign((-Pmat(1,2)+Pmat(2,1))/4/qt00);
end

if abs(qt10)>1e-8, 

qt20=qt20*sign((Pmat(1,2)+Pmat(2,1))/4/qt10);
qt30=qt30*sign((Pmat(1,3)+Pmat(3,1))/4/qt10);
qt00=qt00*sign((Pmat(3,2)-Pmat(2,3))/4/qt10);
end

if abs(qt20)>1e-8, 
qt10=qt10*sign((Pmat(1,2)+Pmat(2,1))/4/qt20);
qt30=qt30*sign((Pmat(2,3)+Pmat(3,2))/4/qt20);
qt00=qt00*sign((Pmat(1,3)-Pmat(3,1))/4/qt20);
end

if abs(qt30)>1e-8, 
qt20=qt20*sign((Pmat(3,2)+Pmat(2,3))/4/qt30);
qt10=qt10*sign((Pmat(1,3)+Pmat(3,1))/4/qt30);
qt00=qt00*sign((-Pmat(1,2)+Pmat(2,1))/4/qt30);
end

% Q=[qt00 qt10 qt20 qt30], %  ********* devrait avoir une norme 1

Q=[qt00 qt10 qt20 qt30]/norm([qt00 qt10 qt20 qt30]);

% normQ=norm(Q),% ******** vrifi *******

% energie=0.5*[vp0 vq0 vr0]*Asat*[vp0 vq0 vr0]',  %  ********  Energie devrait rester constante

etat_init=[vp0 vq0 vr0 Q(1) Q(2) Q(3) Q(4)]; 

% clear trac altitude qt00 qt10 qt20 qt30 vp0 vq0 vr0 Q Pmat

end








